Attribute VB_Name = "APIStuff"
Option Explicit

Public m_OldWindowProcs As Collection

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const WM_CONTEXTMENU = &H7B
' Pass along all messages except the one that
' makes the context menu appear.
Public Function NewWindowProc(ByVal hWnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Const WM_NCDESTROY = &H82
Dim old_window_proc As Long

    ' Get the TextBox's original WindowProc.
    old_window_proc = m_OldWindowProcs("=" & Format$(hWnd))

    ' See if the TextBox is being destroyed.
    If msg = WM_NCDESTROY Then
        ' Restore the original WindowProc.
        SetWindowLong _
            hWnd, GWL_WNDPROC, _
            old_window_proc

        ' Remove this entry from the collection.
        m_OldWindowProcs.Remove "=" & Format$(hWnd)
    End If

    ' Pass messages other than WM_CONTEXTMENU
    ' the the original WindowProc.
    If msg <> WM_CONTEXTMENU Then _
        NewWindowProc = CallWindowProc( _
            old_window_proc, hWnd, msg, _
            wParam, lParam)
End Function
' Subclass to remove this TextBox's context menu.
Public Sub RemoveContextMenu(ByVal txt As TextBox)
    ' Initialize the collection.
    If m_OldWindowProcs Is Nothing Then Set m_OldWindowProcs = New Collection

    ' Subclass, saving the old WindowProc's
    ' address using the hWnd as a key.
    m_OldWindowProcs.Add _
        SetWindowLong( _
            txt.hWnd, GWL_WNDPROC, _
            AddressOf NewWindowProc), _
        "=" & Format$(txt.hWnd)
End Sub
